Index: tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/editors/ChartEditor.java
===================================================================
--- tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/editors/ChartEditor.java	(revision 1334)
+++ tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/editors/ChartEditor.java	(revision 1335)
@@ -1,655 +1,655 @@
-package org.txm.chartsengine.rcp.editors;
-
-
-import java.io.File;
-
-import javax.swing.JComponent;
-
-import org.eclipse.core.runtime.CoreException;
-import org.eclipse.core.runtime.IConfigurationElement;
-import org.eclipse.core.runtime.Platform;
-import org.eclipse.swt.SWT;
-import org.eclipse.swt.layout.GridData;
-import org.eclipse.swt.widgets.Composite;
-import org.eclipse.swt.widgets.Group;
-import org.eclipse.ui.PlatformUI;
-import org.eclipse.ui.contexts.IContextActivation;
-import org.eclipse.ui.contexts.IContextService;
-import org.eclipse.ui.part.MultiPageEditorPart;
-import org.txm.chartsengine.core.ChartsEngine;
-import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
-import org.txm.chartsengine.core.results.ChartResult;
-import org.txm.chartsengine.rcp.SWTChartsComponentsProvider;
-import org.txm.chartsengine.rcp.events.EventCallBack;
-import org.txm.chartsengine.rcp.events.EventCallBackHandler;
-import org.txm.chartsengine.rcp.messages.SWTComponentsProviderMessages;
-import org.txm.chartsengine.rcp.swt.AdvancedChartEditorToolBar;
-import org.txm.chartsengine.rcp.swt.ChartComposite;
-import org.txm.chartsengine.rcp.swt.ChartEditorToolBar;
-import org.txm.rcp.editors.TXMEditor;
-import org.txm.utils.logger.Log;
-
-/**
- * Base class of all charts SWT <code>EditorPart</code> subclasses.
- * @author sjacquot
- *
- */
-public abstract class ChartEditor<T extends ChartResult> extends TXMEditor<ChartResult>{
-
-	
-	public final static String CONTEXT_ID_CHART_EDITOR = "org.txm.chartsengine.rcp.editors.ChartEditor"; //$NON-NLS-1$
-	
-	/**
-	 * The tool bar.
-	 */
-	protected ChartEditorToolBar chartToolBar;
-
-	
-	/**
-	 * The advanced tool bar.
-	 */
-	protected AdvancedChartEditorToolBar advancedChartToolBar;
-	
-	/**
-	 * The advanced rendering parameters composite.
-	 */
-	protected Composite advancedToolBarComposite;
-	
-	/**
-	 * The advanced rendering parameters group.
-	 */
-	protected Group advancedToolBarGroup;
-
-	/**
-	 * The chart drawing area composite.
-	 */
-	protected ChartComposite chartComposite;
-
-	/**
-	 * To check whether this editor was already opened when calling SWTChartsComponentsProvider.openEditor().
-	 */
-	protected boolean wasAlreadyOpened;
-	
-	/**
-	 * The multi pages editor which contains this editor if exists.
-	 */
-	protected MultiPageEditorPart parentMultiPagesEditor = null;
-
-	/**
-	 * Token used to deactivate the context after it has been activated.
-	 */
-	protected IContextActivation contextActivationToken;
-	
-
-	/**
-	 *
-	 */
-	public ChartEditor()	{
-		super();
-	}
-
-
-	/**
-	 * 
-	 * @param swtComponentsProvider
-	 * @param chartEditorInput
-	 */
-	protected ChartEditor(ChartEditorInput chartEditorInput) {
-		this.setInput(chartEditorInput);
-		this.setPartName(chartEditorInput.getName());
-		
-		this.wasAlreadyOpened = false;
-	}
-
-	
-	/**
-	 * Subclasses manual creation.
-	 */
-	public abstract void __createPartControl();
-	
-	
-	@Override
-	public final void _createPartControl() {
-		
-		// Toolbar
-		this.chartToolBar = new ChartEditorToolBar(this, this.getFirstLineComposite(), null, SWT.FLAT | SWT.RIGHT);
-		this.getFirstLineComposite().getLayout().numColumns += 1;
-		//this.chartToolBar.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_RED));
-
-		// Advanced tool bar
-		//this.advancedToolBarComposite = new Composite(parent, SWT.NONE);
-		Group group = this.topToolBar.installGroup(SWTComponentsProviderMessages.toolbar_rendering, SWTComponentsProviderMessages.toolbar_showHideRenderingParameters, 
-				"platform:/plugin/org.txm.chartsengine.rcp/icons/show_rendering_parameters.png",  //$NON-NLS-1$
-				"platform:/plugin/org.txm.chartsengine.rcp/icons/hide_rendering_parameters.png", //$NON-NLS-1$
-				false);
-		this.advancedChartToolBar = new AdvancedChartEditorToolBar(this, group, this.getParametersGroupsComposite(), SWT.FLAT);
-		//this.advancedChartToolBar.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_WHITE));
-//		this.advancedToolBarComposite.pack(true);
-
-		// Remove parent composites
-		//TODO MD: hack ?
-		//this.resultArea.dispose();
-		
-		// Chart composite
-		this.chartComposite = SWTChartsComponentsProvider.getComponentsProvider(this.getResult().getChartsEngine()).createComposite(this, getResultArea());
-		
-		GridData gd = new GridData(GridData.FILL_BOTH);
-//		gd.grabExcessVerticalSpace = true;
-//		gd.grabExcessHorizontalSpace = true;
-		//gd.horizontalSpan = 2; // 2 for match the command parameters toolbar AND the chart toolbar
-		this.chartComposite.setLayoutData(gd);
-		
-		
-		// Re-add the bottom toolbar
-		//TODO MD: hack ?
-		//this.bottomToolBar = new TXMEditorToolBar(this, SWT.FLAT, "bottom");
-		
-		// FIXME: open dialog box message if the composite doesn't contain any chart (typically when the charts engine doesn't contain chart creator for the specified result data type)
-//		if(composite.getChart() == null)	{
-//			MessageDialog.openWarning(parent.getShell(), "Warning", "Current charts engine can not create chart for " + this.getResultData().getClass().getSimpleName() + " result type. You can set another charts engine in the preferences.");
-//		}
-		
-		// FIXME: background color tests
-		//this.composite.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_WHITE));
-		//parent.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_WHITE));
-
-		//this.refresh(false);
-//
-//		}
-		
-		 // subclasses manual creation
-		this.__createPartControl();
-		
-	}
-
-
-	/**
-	 * Initializes the default context menus.
-	 */
-	public void initDefaultContextMenus()	{
-		SWTChartsComponentsProvider.initDefaultContextMenus(this.chartComposite);
-	}
-	
-
-	/**
-	 * Opens an editor where id is the specified result class name, computes the result then refreshes the editor components.
-	 * @param result
-	 */
-	public static ChartEditor openEditor(ChartResult result) {
-		return openEditor(result, false);
-	}
-
-	public static ChartEditor openEditor(ChartResult result, boolean alwaysRecreateEditor)	{
-		return openEditor(result, result.getClass().getName(), alwaysRecreateEditor);
-	}
-	
-	public static ChartEditor openEditor(ChartResult result, String editorPartId)	{
-		return openEditor(result, editorPartId, false);
-	}
-	
-	
-	/**
-	 * Opens an editor specified by its id, computes the specified result then refreshes the editor components.
-	 * @param result
-	 * @param editorPartId
-	 * @return
-	 */
-	public static ChartEditor openEditor(ChartResult result, String editorPartId, boolean alwaysRecreateEditor)	{
-		
-		ChartEditorInput<ChartResult> editorInput = new ChartEditorInput<ChartResult>(result);
-		editorInput.setAlwaysRecreateEditor(alwaysRecreateEditor);
-		
-		return (ChartEditor) openEditor(editorInput, editorPartId);
-	}
-
-
-
-	@Override
-	public void updateResultFromEditor() {
-		// does nothing by default
-	}
-	
-	/**
-	 * Synchronizes the editor with the chart result. 
-	 * Dedicated to dynamically change the editor components values from the stored result data.
-	 */
-	public abstract void updateEditorFromChart(boolean update);
-	
-	
-	@Override
-	public final void updateEditorFromResult(boolean update) {
-		
-		this.updateEditorFromChart(update);
-		
-		// check that the charts engine used for the result matches the SWT components provider otherwise find a suitable components provider
-		if(this.getResult().getChartsEngine() != this.getSWTChartsComponentsProvider().getChartsEngine())	{
-			
-			Log.finest("ChartEditor.__updateEditorFromResult(): result charts engine  = " + this.getResult().getChartsEngine().getName() + " / Editor charts engine = " + this.getSWTChartsComponentsProvider().getChartsEngine().getName() + "."); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-			
-			this.getEditorInput().setSWTChartsComponentsProvider(SWTChartsComponentsProvider.getComponentsProvider(this.getResult().getChartsEngine()));
-			this.getSWTChartsComponentsProvider().setChartsEngine(this.getResult().getChartsEngine());
-			
-			Log.finest("ChartEditor.__updateEditorFromResult(): charts engine used to create the chart does not match the editor one. The SWT components provider has been changed to match it: " + this.getSWTChartsComponentsProvider() + "."); //$NON-NLS-1$ //$NON-NLS-2$
-			
-			// recreating the chart composite
-			Composite parent = this.chartComposite.getParent();
-			this.chartComposite.dispose();
-			this.chartComposite = this.getSWTChartsComponentsProvider().createComposite(this, parent);
-			
-			GridData gd = new GridData(GridData.FILL_BOTH);
-			this.chartComposite.setLayoutData(gd);
-			parent.layout();
-		}
-
-		
-		
-		boolean needInit = (this.chartComposite.getChartComponent() == null) && (this.getResult().getChart() != null);
-		
-		// loading chart
-		this.getResult().subTask("Loading chart."); //$NON-NLS-1$
-		this.loadChart();
-		
-		
-		// FIXME: this code should be moved in ChartComposit.loadChart()?
-		// if editor wasn't exist:
-		// hiding command parameters, updating tool bar buttons states, registering context menus and event user callbacks 
-		if(needInit
-				
-				//!update
-//				&& !this.getResult().isChartDirty()
-				)	{
-//			getSite().getShell().getDisplay().syncExec(new Runnable() {
-//				@Override
-//				public void run() {
-					// FIXME: decide if we automatically hide or not the parameter area
-					//editor2.getTopToolbar().setComputingParametersVisible(false);
-					
-					// FIXME: tests to disable command if the chart is null and reenable it when the chart is computed 
-					//editor2.getChartToolBar().synchronize();
-					
-					// initialize the default shared context menus as Export, etc.
-					initDefaultContextMenus();
-			
-					// registers user entries event call back extensions
-					registerEventCallBackExtensions();
-					
-					//FIXME: test to contribute to menu only in some context and also for key binding
-					// create chart editor part context
-//					this.activateContext();
-//					IContextService contextService = (IContextService)getSite().getService(IContextService.class);
-//					this.contextActivationToken = contextService.activateContext(CONTEXT_ID_CHART_EDITOR);
-	//				// create chart composite context
-	//				contextService.activateContext(this.chartComposite.getClass().getName());
-					
-					//FIXME: description test
-					//editor2..setContentDescription("details");
-					//editor2..setContentDescription(this.getResultData().getDetails());
-	
-					initializeAWTDelegationListeners();
-					
-//				}
-//			});
-		}
-		
-		
-		if(this.parentMultiPagesEditor == null)	{
-			this.forceFocus();			
-		}
-	}
-
-	/**
-	 * Activates the chart editor context.
-	 */
-	public void activateContext()	{
-		IContextService contextService = (IContextService)getSite().getService(IContextService.class);
-		this.contextActivationToken = contextService.activateContext(CONTEXT_ID_CHART_EDITOR);
-	}
-	
-
-	/**
-	 * Deactivates the chart editor context.
-	 */
-	public void deactivateContext()	{
-		IContextService contextService = (IContextService)getSite().getService(IContextService.class);
-		contextService.deactivateContext(this.contextActivationToken);
-	}
-	
-	/**
-	 * Registers user entries event call back extensions.
-	 */
-	public void registerEventCallBackExtensions()	{
-		String extensionPointId = "org.txm.chartsengine.eventcallback"; //$NON-NLS-1$
-		IConfigurationElement[] contributions = Platform.getExtensionRegistry().getConfigurationElementsFor(extensionPointId);
-		
-		for(int i = 0; i < contributions.length; i++) {
-			if(
-				(
-						contributions[i].getAttribute("chartsEngineName") == null || //$NON-NLS-1$ // for callback that can be used for all charts engine implementations 
-						contributions[i].getAttribute("chartsEngineName").equals(this.getChartsEngine().getName()) //$NON-NLS-1$
-				)
-				&&
-				contributions[i].getAttribute("resultDataClass") != null //$NON-NLS-1$
-				&& contributions[i].getAttribute("resultDataClass").equals(this.getResult().getClass().getName()) //$NON-NLS-1$
-				
-				&& ((contributions[i].getAttribute("chartType") == null && this.getChartType().equals(ChartsEnginePreferences.DEFAULT_CHART_TYPE) //$NON-NLS-1$
-					||
-					contributions[i].getAttribute("chartType") != null && !this.getChartType().equals(ChartsEnginePreferences.DEFAULT_CHART_TYPE) && contributions[i].getAttribute("chartType").equals(this.getChartType()) //$NON-NLS-1$ //$NON-NLS-2$
-					)  //$NON-NLS-1$
-				)
-				
-			)	{
-				try {
-					EventCallBack eventCallBack = (EventCallBack)contributions[i].createExecutableExtension("class");  //$NON-NLS-1$
-					
-					eventCallBack.setChartEditor(this);
-					
-					EventCallBackHandler mouseHandler = this.chartComposite.getMouseCallBackHandler();
-					if(mouseHandler != null && mouseHandler.getEventCallBack(eventCallBack.getClass()) == null)	 {
-
-						Log.info("ChartEditor.registerEventCallBackExtensions(): call back of type " + eventCallBack.getClass()  //$NON-NLS-1$
-								+ " registered in mouse handler (chart editor = " + this.getClass()  //$NON-NLS-1$
-								+ ", result data class = " + this.getResult().getClass()  //$NON-NLS-1$
-								+ ", chart type = " + this.getChartType()  //$NON-NLS-1$
-								+ ").");  //$NON-NLS-1$
-						
-						mouseHandler.registerEventCallBack(eventCallBack);
-					}
-					EventCallBackHandler keyboardHandler = this.chartComposite.getKeyCallBackHandler();
-					if(keyboardHandler != null && keyboardHandler.getEventCallBack(eventCallBack.getClass()) == null)	 {
-						
-						Log.info("ChartEditor.registerEventCallBackExtensions(): call back of type " + eventCallBack.getClass()  //$NON-NLS-1$
-								+ " registered in key handler (chart editor = " + this.getClass()  //$NON-NLS-1$
-								+ ", result data class = " + this.getResult().getClass()  //$NON-NLS-1$
-								+ ", chart type = " + this.getChartType()  //$NON-NLS-1$
-								+ ").");  //$NON-NLS-1$
-						
-						keyboardHandler.registerEventCallBack(eventCallBack);
-					}
-				}
-				catch(CoreException e) {
-					e.printStackTrace();
-				}
-				break;
-			}
-		}
-		
-	}
-	
-	/**
-	 * Activate the editor in the UI.
-	 */
-	//FIXME: this method doesn't work for Multi pages editor, eg. can not activating CAFactorialMapEditor stored in the CAEditor
-	public void activate()	{
-		// Activate the parent multi pages editor instead of this editor if it exists
-		if(this.parentMultiPagesEditor != null)	{
-			PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().activate(this.parentMultiPagesEditor);
-		}
-		else	{
-			// TODO: for focus and activation debug
-//			System.out.println("ChartEditor.activate(): current active editor = " + PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart());
-//			System.out.println("ChartEditor.activate(): activating: " + this);
-//	//		PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().bringToTop(this);
-			PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().activate(this);
-//			System.out.println("ChartEditor.activate(): new active editor = " + PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart());
-		}
-	}
-
-	/**
-	 * Forces the Composite to get the focus.
-	 */
-	public void forceFocus()	{
-		// FIXME: debug
-		//System.err.println("ChartEditor.forceFocus()");
-
-		//this.chartComposite.setFocus();
-		this.chartComposite.notifyListeners(SWT.FocusIn, null); // Needed to force the composite listener to handle the focus event
-	}
-
-
-	@Override
-	public void setFocus() {
-
-		// FIXME: debug
-		//System.err.println("ChartEditor.setFocus()");
-
-		this.chartComposite.setFocus();
-
-	}
-
-	
-	
-	
-	
-	
-	/**
-	 * Initialize Swing/AWT events delegation.
-	 * @param swingComponent
-	 */
-	protected void initializeAWTDelegationListeners()	{
-		this.getChartComposite().getChartComponent().setChartEditor(this);
-		SWTChartsComponentsProvider.initializeAWTDelegationListeners(this, (JComponent) this.getEditorInput().getChartContainer());
-	}
-
-	/**
-	 * Convenience method the get the casted linked editor input.
-	 * @return the editorInput
-	 */
-	public ChartEditorInput<T> getEditorInput() {
-		return (ChartEditorInput) super.getEditorInput();
-	}
-
-
-
-	/**
-	 * Gets the chart drawing area composite.
-	 * @return the composite
-	 */
-	public ChartComposite getComposite() {
-		return this.chartComposite;
-	}
-
-
-	/**
-	 * Resets the chart view (zoom, pan, rotation).
-	 */
-	public void resetView() {
-		this.chartComposite.resetView();
-	}
-
-	/**
-	 *  Clears the selected items in chart.
-	 */
-	public void clearChartItemsSelection()	{
-		this.chartComposite.clearChartItemsSelection();
-	}
-	
-	/**
-	 * Zooms the chart view at x and y coordinates.
-	 * @param x
-	 * @param y
-	 * @param zoomIn
-	 */
-	public void zoom(double x, double y, boolean zoomIn)	{
-		this.chartComposite.zoom(x, y, zoomIn);
-	}
-
-	/**
-	 * Pans the chart view.
-	 * @param chartComponent
-	 * @param srcX
-	 * @param srcY
-	 * @param dstX
-	 * @param dstY
-	 * @param panFactor
-	 */
-	public void pan(double srcX, double srcY, double dstX, double dstY, double panFactor)	{
-		this.chartComposite.pan(srcX, srcY, dstX, dstY, panFactor);
-	}
-	
-	
-	/**
-	 * Copy the current chart view to clipboard.
-	 */
-	public void copyChartViewToClipboard()	{
-		this.chartComposite.copyChartViewToClipboard();
-	}
-
-	/**
-	 * Loads the chart from the chart object stored into the composite.
-	 * @param resetView
-	 * @param clearChartItemsSelection
-	 */
-	public void loadChart()	{
-		getSite().getShell().getDisplay().syncExec(new Runnable() {
-			@Override
-			public void run() {
-				chartComposite.loadChart(
-						getResult().needsToResetView(), 
-						getResult().needsToClearItemsSelection());
-			}
-		});
-	}
-	
-	/**
-	 * Creates the chart container component from the chart object stored into the composite.
-	 */
-	// FIXME: became useless?
-//	public void createChartContainer()	{
-//		this.getSWTChartsComponentsProvider().createChartContainer(this.getEditorInput());
-//	}
-	
-	/**
-	 * Disposes the editor.
-	 * Implementations using a Composite to embed AWT/Swing components should manually call this.composite.dispose() in the redefined method.
-	 */
-	public void dispose()	{
-		if (chartComposite != null && !chartComposite.isDisposed()) {
-			this.chartComposite.dispose();
-		}
-		super.dispose();
-	}
-
-	/**
-	 * Returns the tool bar of this editor.
-	 * @return the toolBar
-	 */
-	public ChartEditorToolBar getToolBar() {
-		return chartToolBar;
-	}
-
-	/**
-	 * Returns the advanced tool bar of this editor.
-	 * @return
-	 */
-	public AdvancedChartEditorToolBar getAdvancedToolBar()	{
-		return this.advancedChartToolBar;
-	}
-	
-
-	/**
-	 * Gets the chart type. A same result can be drawn as multiple chart types (eg. pie, bar, etc.).
-	 * @return
-	 */
-	public String getChartType()	{
-		return this.getResult().getChartType();
-	}
-	
-	/**
-	 * Returns the chart associated with the editor.
-	 * @return
-	 */
-	public Object getChart()	{
-		return this.getResult().getChart();
-	}
-	
-	/**
-	 * Returns the chart components provider associated with the editor (through its <code>ChartEditorInput</code>).
-	 * @return
-	 */
-	public SWTChartsComponentsProvider getSWTChartsComponentsProvider()	{
-		return this.getEditorInput().getSWTChartsComponentsProvider();
-	}
-
-	/**
-	 * Gets the charts engine associated with the editor (through its <code>ChartEditorInput</code>).
-	 * @return
-	 */
-	public ChartsEngine getChartsEngine()	{
-		return this.getResult().getChartsEngine();
-	}
-
-	/**
-	 * Exports the current view of the chart editor in the specified file.
-	 * @param file
-	 * @param fileFormat
-	 * @return
-	 */
-	public File exportView(File file, String fileFormat)	{
-		return this.getSWTChartsComponentsProvider().exportView(this, file, fileFormat);
-	}
-
-	/**
-	 * Gets the parent multipages editor part if exists.
-	 * @return the parentMultiPagesEditor
-	 */
-	public MultiPageEditorPart getParentMultiPagesEditor() {
-		return parentMultiPagesEditor;
-	}
-
-	/**
-	 * Sets the specified multipages editor part as parent of this one.
-	 * @param parentMultiPagesEditor the parentMultiPagesEditor to set
-	 */
-	public void setParentMultiPagesEditor(MultiPageEditorPart parentMultiPagesEditor) {
-		this.parentMultiPagesEditor = parentMultiPagesEditor;
-	}
-
-	/**
-	 * To check whether this editor was already opened when calling SWTChartsComponentsProvider.openEditor().
-	 * @return the wasAlreadyOpened
-	 */
-	public boolean wasAlreadyOpened() {
-		return wasAlreadyOpened;
-	}
-
-	/**
-	 * To check whether this editor was already opened when calling SWTChartsComponentsProvider.openEditor().
-	 * @param wasAlreadyOpened the wasAlreadyOpened to set
-	 */
-	public void setWasAlreadyOpened(boolean wasAlreadyOpened) {
-		this.wasAlreadyOpened = wasAlreadyOpened;
-	}
-
-	/**
-	 * Checks whatever the chart composite has the focus or not.
-	 * @return <code>true</code> if the chart composite has the focus otherwise <code>false</code>
-	 */
-	public boolean hasFocus()	{
-		return this.chartComposite.hasFocus();
-	}
-
-	/**
-	 * Gets the chart composite.
-	 * @return the chartComposite
-	 */
-	public ChartComposite getChartComposite() {
-		return chartComposite;
-	}
-
-	/**
-	 * Gets the chart toolbar.
-	 * @return the chartToolBar
-	 */
-	public ChartEditorToolBar getChartToolBar() {
-		return chartToolBar;
-	}
-
-	
-	
-	@Override
-	public T getResult()	{
-		return (T) this.getEditorInput().getResult();
-	}
-	
-
-}
+package org.txm.chartsengine.rcp.editors;
+
+
+import java.io.File;
+
+import javax.swing.JComponent;
+
+import org.eclipse.core.runtime.CoreException;
+import org.eclipse.core.runtime.IConfigurationElement;
+import org.eclipse.core.runtime.Platform;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.layout.GridData;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Group;
+import org.eclipse.ui.PlatformUI;
+import org.eclipse.ui.contexts.IContextActivation;
+import org.eclipse.ui.contexts.IContextService;
+import org.eclipse.ui.part.MultiPageEditorPart;
+import org.txm.chartsengine.core.ChartsEngine;
+import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
+import org.txm.chartsengine.core.results.ChartResult;
+import org.txm.chartsengine.rcp.SWTChartsComponentsProvider;
+import org.txm.chartsengine.rcp.events.EventCallBack;
+import org.txm.chartsengine.rcp.events.EventCallBackHandler;
+import org.txm.chartsengine.rcp.messages.SWTComponentsProviderMessages;
+import org.txm.chartsengine.rcp.swt.AdvancedChartEditorToolBar;
+import org.txm.chartsengine.rcp.swt.ChartComposite;
+import org.txm.chartsengine.rcp.swt.ChartEditorToolBar;
+import org.txm.rcp.editors.TXMEditor;
+import org.txm.utils.logger.Log;
+
+/**
+ * Base class of all charts SWT <code>EditorPart</code> subclasses.
+ * @author sjacquot
+ *
+ */
+public abstract class ChartEditor<T extends ChartResult> extends TXMEditor<ChartResult>{
+
+	
+	public final static String CONTEXT_ID_CHART_EDITOR = "org.txm.chartsengine.rcp.editors.ChartEditor"; //$NON-NLS-1$
+	
+	/**
+	 * The tool bar.
+	 */
+	protected ChartEditorToolBar chartToolBar;
+
+	
+	/**
+	 * The advanced tool bar.
+	 */
+	protected AdvancedChartEditorToolBar advancedChartToolBar;
+	
+	/**
+	 * The advanced rendering parameters composite.
+	 */
+	protected Composite advancedToolBarComposite;
+	
+	/**
+	 * The advanced rendering parameters group.
+	 */
+	protected Group advancedToolBarGroup;
+
+	/**
+	 * The chart drawing area composite.
+	 */
+	protected ChartComposite chartComposite;
+
+	/**
+	 * To check whether this editor was already opened when calling SWTChartsComponentsProvider.openEditor().
+	 */
+	protected boolean wasAlreadyOpened;
+	
+	/**
+	 * The multi pages editor which contains this editor if exists.
+	 */
+	protected MultiPageEditorPart parentMultiPagesEditor = null;
+
+	/**
+	 * Token used to deactivate the context after it has been activated.
+	 */
+	protected IContextActivation contextActivationToken;
+	
+
+	/**
+	 *
+	 */
+	public ChartEditor()	{
+		super();
+	}
+
+
+	/**
+	 * 
+	 * @param swtComponentsProvider
+	 * @param chartEditorInput
+	 */
+	protected ChartEditor(ChartEditorInput chartEditorInput) {
+		this.setInput(chartEditorInput);
+		this.setPartName(chartEditorInput.getName());
+		
+		this.wasAlreadyOpened = false;
+	}
+
+	
+	/**
+	 * Subclasses manual creation.
+	 */
+	public abstract void __createPartControl();
+	
+	
+	@Override
+	public final void _createPartControl() {
+		
+		// Toolbar
+		this.chartToolBar = new ChartEditorToolBar(this, this.getFirstLineComposite(), null, SWT.FLAT | SWT.RIGHT);
+		this.getFirstLineComposite().getLayout().numColumns += 1;
+		//this.chartToolBar.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_RED));
+
+		// Advanced tool bar
+		//this.advancedToolBarComposite = new Composite(parent, SWT.NONE);
+		Group group = this.topToolBar.installGroup(SWTComponentsProviderMessages.rendering, SWTComponentsProviderMessages.showHideRenderingParameters, 
+				"platform:/plugin/org.txm.chartsengine.rcp/icons/show_rendering_parameters.png",  //$NON-NLS-1$
+				"platform:/plugin/org.txm.chartsengine.rcp/icons/hide_rendering_parameters.png", //$NON-NLS-1$
+				false);
+		this.advancedChartToolBar = new AdvancedChartEditorToolBar(this, group, this.getParametersGroupsComposite(), SWT.FLAT);
+		//this.advancedChartToolBar.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_WHITE));
+//		this.advancedToolBarComposite.pack(true);
+
+		// Remove parent composites
+		//TODO MD: hack ?
+		//this.resultArea.dispose();
+		
+		// Chart composite
+		this.chartComposite = SWTChartsComponentsProvider.getComponentsProvider(this.getResult().getChartsEngine()).createComposite(this, getResultArea());
+		
+		GridData gd = new GridData(GridData.FILL_BOTH);
+//		gd.grabExcessVerticalSpace = true;
+//		gd.grabExcessHorizontalSpace = true;
+		//gd.horizontalSpan = 2; // 2 for match the command parameters toolbar AND the chart toolbar
+		this.chartComposite.setLayoutData(gd);
+		
+		
+		// Re-add the bottom toolbar
+		//TODO MD: hack ?
+		//this.bottomToolBar = new TXMEditorToolBar(this, SWT.FLAT, "bottom");
+		
+		// FIXME: open dialog box message if the composite doesn't contain any chart (typically when the charts engine doesn't contain chart creator for the specified result data type)
+//		if(composite.getChart() == null)	{
+//			MessageDialog.openWarning(parent.getShell(), "Warning", "Current charts engine can not create chart for " + this.getResultData().getClass().getSimpleName() + " result type. You can set another charts engine in the preferences.");
+//		}
+		
+		// FIXME: background color tests
+		//this.composite.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_WHITE));
+		//parent.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_WHITE));
+
+		//this.refresh(false);
+//
+//		}
+		
+		 // subclasses manual creation
+		this.__createPartControl();
+		
+	}
+
+
+	/**
+	 * Initializes the default context menus.
+	 */
+	public void initDefaultContextMenus()	{
+		SWTChartsComponentsProvider.initDefaultContextMenus(this.chartComposite);
+	}
+	
+
+	/**
+	 * Opens an editor where id is the specified result class name, computes the result then refreshes the editor components.
+	 * @param result
+	 */
+	public static ChartEditor openEditor(ChartResult result) {
+		return openEditor(result, false);
+	}
+
+	public static ChartEditor openEditor(ChartResult result, boolean alwaysRecreateEditor)	{
+		return openEditor(result, result.getClass().getName(), alwaysRecreateEditor);
+	}
+	
+	public static ChartEditor openEditor(ChartResult result, String editorPartId)	{
+		return openEditor(result, editorPartId, false);
+	}
+	
+	
+	/**
+	 * Opens an editor specified by its id, computes the specified result then refreshes the editor components.
+	 * @param result
+	 * @param editorPartId
+	 * @return
+	 */
+	public static ChartEditor openEditor(ChartResult result, String editorPartId, boolean alwaysRecreateEditor)	{
+		
+		ChartEditorInput<ChartResult> editorInput = new ChartEditorInput<ChartResult>(result);
+		editorInput.setAlwaysRecreateEditor(alwaysRecreateEditor);
+		
+		return (ChartEditor) openEditor(editorInput, editorPartId);
+	}
+
+
+
+	@Override
+	public void updateResultFromEditor() {
+		// does nothing by default
+	}
+	
+	/**
+	 * Synchronizes the editor with the chart result. 
+	 * Dedicated to dynamically change the editor components values from the stored result data.
+	 */
+	public abstract void updateEditorFromChart(boolean update);
+	
+	
+	@Override
+	public final void updateEditorFromResult(boolean update) {
+		
+		this.updateEditorFromChart(update);
+		
+		// check that the charts engine used for the result matches the SWT components provider otherwise find a suitable components provider
+		if(this.getResult().getChartsEngine() != this.getSWTChartsComponentsProvider().getChartsEngine())	{
+			
+			Log.finest("ChartEditor.__updateEditorFromResult(): result charts engine  = " + this.getResult().getChartsEngine().getName() + " / Editor charts engine = " + this.getSWTChartsComponentsProvider().getChartsEngine().getName() + "."); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+			
+			this.getEditorInput().setSWTChartsComponentsProvider(SWTChartsComponentsProvider.getComponentsProvider(this.getResult().getChartsEngine()));
+			this.getSWTChartsComponentsProvider().setChartsEngine(this.getResult().getChartsEngine());
+			
+			Log.finest("ChartEditor.__updateEditorFromResult(): charts engine used to create the chart does not match the editor one. The SWT components provider has been changed to match it: " + this.getSWTChartsComponentsProvider() + "."); //$NON-NLS-1$ //$NON-NLS-2$
+			
+			// recreating the chart composite
+			Composite parent = this.chartComposite.getParent();
+			this.chartComposite.dispose();
+			this.chartComposite = this.getSWTChartsComponentsProvider().createComposite(this, parent);
+			
+			GridData gd = new GridData(GridData.FILL_BOTH);
+			this.chartComposite.setLayoutData(gd);
+			parent.layout();
+		}
+
+		
+		
+		boolean needInit = (this.chartComposite.getChartComponent() == null) && (this.getResult().getChart() != null);
+		
+		// loading chart
+		this.getResult().subTask("Loading chart."); //$NON-NLS-1$
+		this.loadChart();
+		
+		
+		// FIXME: this code should be moved in ChartComposit.loadChart()?
+		// if editor wasn't exist:
+		// hiding command parameters, updating tool bar buttons states, registering context menus and event user callbacks 
+		if(needInit
+				
+				//!update
+//				&& !this.getResult().isChartDirty()
+				)	{
+//			getSite().getShell().getDisplay().syncExec(new Runnable() {
+//				@Override
+//				public void run() {
+					// FIXME: decide if we automatically hide or not the parameter area
+					//editor2.getTopToolbar().setComputingParametersVisible(false);
+					
+					// FIXME: tests to disable command if the chart is null and reenable it when the chart is computed 
+					//editor2.getChartToolBar().synchronize();
+					
+					// initialize the default shared context menus as Export, etc.
+					initDefaultContextMenus();
+			
+					// registers user entries event call back extensions
+					registerEventCallBackExtensions();
+					
+					//FIXME: test to contribute to menu only in some context and also for key binding
+					// create chart editor part context
+//					this.activateContext();
+//					IContextService contextService = (IContextService)getSite().getService(IContextService.class);
+//					this.contextActivationToken = contextService.activateContext(CONTEXT_ID_CHART_EDITOR);
+	//				// create chart composite context
+	//				contextService.activateContext(this.chartComposite.getClass().getName());
+					
+					//FIXME: description test
+					//editor2..setContentDescription("details");
+					//editor2..setContentDescription(this.getResultData().getDetails());
+	
+					initializeAWTDelegationListeners();
+					
+//				}
+//			});
+		}
+		
+		
+		if(this.parentMultiPagesEditor == null)	{
+			this.forceFocus();			
+		}
+	}
+
+	/**
+	 * Activates the chart editor context.
+	 */
+	public void activateContext()	{
+		IContextService contextService = (IContextService)getSite().getService(IContextService.class);
+		this.contextActivationToken = contextService.activateContext(CONTEXT_ID_CHART_EDITOR);
+	}
+	
+
+	/**
+	 * Deactivates the chart editor context.
+	 */
+	public void deactivateContext()	{
+		IContextService contextService = (IContextService)getSite().getService(IContextService.class);
+		contextService.deactivateContext(this.contextActivationToken);
+	}
+	
+	/**
+	 * Registers user entries event call back extensions.
+	 */
+	public void registerEventCallBackExtensions()	{
+		String extensionPointId = "org.txm.chartsengine.eventcallback"; //$NON-NLS-1$
+		IConfigurationElement[] contributions = Platform.getExtensionRegistry().getConfigurationElementsFor(extensionPointId);
+		
+		for(int i = 0; i < contributions.length; i++) {
+			if(
+				(
+						contributions[i].getAttribute("chartsEngineName") == null || //$NON-NLS-1$ // for callback that can be used for all charts engine implementations 
+						contributions[i].getAttribute("chartsEngineName").equals(this.getChartsEngine().getName()) //$NON-NLS-1$
+				)
+				&&
+				contributions[i].getAttribute("resultDataClass") != null //$NON-NLS-1$
+				&& contributions[i].getAttribute("resultDataClass").equals(this.getResult().getClass().getName()) //$NON-NLS-1$
+				
+				&& ((contributions[i].getAttribute("chartType") == null && this.getChartType().equals(ChartsEnginePreferences.DEFAULT_CHART_TYPE) //$NON-NLS-1$
+					||
+					contributions[i].getAttribute("chartType") != null && !this.getChartType().equals(ChartsEnginePreferences.DEFAULT_CHART_TYPE) && contributions[i].getAttribute("chartType").equals(this.getChartType()) //$NON-NLS-1$ //$NON-NLS-2$
+					)  //$NON-NLS-1$
+				)
+				
+			)	{
+				try {
+					EventCallBack eventCallBack = (EventCallBack)contributions[i].createExecutableExtension("class");  //$NON-NLS-1$
+					
+					eventCallBack.setChartEditor(this);
+					
+					EventCallBackHandler mouseHandler = this.chartComposite.getMouseCallBackHandler();
+					if(mouseHandler != null && mouseHandler.getEventCallBack(eventCallBack.getClass()) == null)	 {
+
+						Log.info("ChartEditor.registerEventCallBackExtensions(): call back of type " + eventCallBack.getClass()  //$NON-NLS-1$
+								+ " registered in mouse handler (chart editor = " + this.getClass()  //$NON-NLS-1$
+								+ ", result data class = " + this.getResult().getClass()  //$NON-NLS-1$
+								+ ", chart type = " + this.getChartType()  //$NON-NLS-1$
+								+ ").");  //$NON-NLS-1$
+						
+						mouseHandler.registerEventCallBack(eventCallBack);
+					}
+					EventCallBackHandler keyboardHandler = this.chartComposite.getKeyCallBackHandler();
+					if(keyboardHandler != null && keyboardHandler.getEventCallBack(eventCallBack.getClass()) == null)	 {
+						
+						Log.info("ChartEditor.registerEventCallBackExtensions(): call back of type " + eventCallBack.getClass()  //$NON-NLS-1$
+								+ " registered in key handler (chart editor = " + this.getClass()  //$NON-NLS-1$
+								+ ", result data class = " + this.getResult().getClass()  //$NON-NLS-1$
+								+ ", chart type = " + this.getChartType()  //$NON-NLS-1$
+								+ ").");  //$NON-NLS-1$
+						
+						keyboardHandler.registerEventCallBack(eventCallBack);
+					}
+				}
+				catch(CoreException e) {
+					e.printStackTrace();
+				}
+				break;
+			}
+		}
+		
+	}
+	
+	/**
+	 * Activate the editor in the UI.
+	 */
+	//FIXME: this method doesn't work for Multi pages editor, eg. can not activating CAFactorialMapEditor stored in the CAEditor
+	public void activate()	{
+		// Activate the parent multi pages editor instead of this editor if it exists
+		if(this.parentMultiPagesEditor != null)	{
+			PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().activate(this.parentMultiPagesEditor);
+		}
+		else	{
+			// TODO: for focus and activation debug
+//			System.out.println("ChartEditor.activate(): current active editor = " + PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart());
+//			System.out.println("ChartEditor.activate(): activating: " + this);
+//	//		PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().bringToTop(this);
+			PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().activate(this);
+//			System.out.println("ChartEditor.activate(): new active editor = " + PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart());
+		}
+	}
+
+	/**
+	 * Forces the Composite to get the focus.
+	 */
+	public void forceFocus()	{
+		// FIXME: debug
+		//System.err.println("ChartEditor.forceFocus()");
+
+		//this.chartComposite.setFocus();
+		this.chartComposite.notifyListeners(SWT.FocusIn, null); // Needed to force the composite listener to handle the focus event
+	}
+
+
+	@Override
+	public void setFocus() {
+
+		// FIXME: debug
+		//System.err.println("ChartEditor.setFocus()");
+
+		this.chartComposite.setFocus();
+
+	}
+
+	
+	
+	
+	
+	
+	/**
+	 * Initialize Swing/AWT events delegation.
+	 * @param swingComponent
+	 */
+	protected void initializeAWTDelegationListeners()	{
+		this.getChartComposite().getChartComponent().setChartEditor(this);
+		SWTChartsComponentsProvider.initializeAWTDelegationListeners(this, (JComponent) this.getEditorInput().getChartContainer());
+	}
+
+	/**
+	 * Convenience method the get the casted linked editor input.
+	 * @return the editorInput
+	 */
+	public ChartEditorInput<T> getEditorInput() {
+		return (ChartEditorInput) super.getEditorInput();
+	}
+
+
+
+	/**
+	 * Gets the chart drawing area composite.
+	 * @return the composite
+	 */
+	public ChartComposite getComposite() {
+		return this.chartComposite;
+	}
+
+
+	/**
+	 * Resets the chart view (zoom, pan, rotation).
+	 */
+	public void resetView() {
+		this.chartComposite.resetView();
+	}
+
+	/**
+	 *  Clears the selected items in chart.
+	 */
+	public void clearChartItemsSelection()	{
+		this.chartComposite.clearChartItemsSelection();
+	}
+	
+	/**
+	 * Zooms the chart view at x and y coordinates.
+	 * @param x
+	 * @param y
+	 * @param zoomIn
+	 */
+	public void zoom(double x, double y, boolean zoomIn)	{
+		this.chartComposite.zoom(x, y, zoomIn);
+	}
+
+	/**
+	 * Pans the chart view.
+	 * @param chartComponent
+	 * @param srcX
+	 * @param srcY
+	 * @param dstX
+	 * @param dstY
+	 * @param panFactor
+	 */
+	public void pan(double srcX, double srcY, double dstX, double dstY, double panFactor)	{
+		this.chartComposite.pan(srcX, srcY, dstX, dstY, panFactor);
+	}
+	
+	
+	/**
+	 * Copy the current chart view to clipboard.
+	 */
+	public void copyChartViewToClipboard()	{
+		this.chartComposite.copyChartViewToClipboard();
+	}
+
+	/**
+	 * Loads the chart from the chart object stored into the composite.
+	 * @param resetView
+	 * @param clearChartItemsSelection
+	 */
+	public void loadChart()	{
+		getSite().getShell().getDisplay().syncExec(new Runnable() {
+			@Override
+			public void run() {
+				chartComposite.loadChart(
+						getResult().needsToResetView(), 
+						getResult().needsToClearItemsSelection());
+			}
+		});
+	}
+	
+	/**
+	 * Creates the chart container component from the chart object stored into the composite.
+	 */
+	// FIXME: became useless?
+//	public void createChartContainer()	{
+//		this.getSWTChartsComponentsProvider().createChartContainer(this.getEditorInput());
+//	}
+	
+	/**
+	 * Disposes the editor.
+	 * Implementations using a Composite to embed AWT/Swing components should manually call this.composite.dispose() in the redefined method.
+	 */
+	public void dispose()	{
+		if (chartComposite != null && !chartComposite.isDisposed()) {
+			this.chartComposite.dispose();
+		}
+		super.dispose();
+	}
+
+	/**
+	 * Returns the tool bar of this editor.
+	 * @return the toolBar
+	 */
+	public ChartEditorToolBar getToolBar() {
+		return chartToolBar;
+	}
+
+	/**
+	 * Returns the advanced tool bar of this editor.
+	 * @return
+	 */
+	public AdvancedChartEditorToolBar getAdvancedToolBar()	{
+		return this.advancedChartToolBar;
+	}
+	
+
+	/**
+	 * Gets the chart type. A same result can be drawn as multiple chart types (eg. pie, bar, etc.).
+	 * @return
+	 */
+	public String getChartType()	{
+		return this.getResult().getChartType();
+	}
+	
+	/**
+	 * Returns the chart associated with the editor.
+	 * @return
+	 */
+	public Object getChart()	{
+		return this.getResult().getChart();
+	}
+	
+	/**
+	 * Returns the chart components provider associated with the editor (through its <code>ChartEditorInput</code>).
+	 * @return
+	 */
+	public SWTChartsComponentsProvider getSWTChartsComponentsProvider()	{
+		return this.getEditorInput().getSWTChartsComponentsProvider();
+	}
+
+	/**
+	 * Gets the charts engine associated with the editor (through its <code>ChartEditorInput</code>).
+	 * @return
+	 */
+	public ChartsEngine getChartsEngine()	{
+		return this.getResult().getChartsEngine();
+	}
+
+	/**
+	 * Exports the current view of the chart editor in the specified file.
+	 * @param file
+	 * @param fileFormat
+	 * @return
+	 */
+	public File exportView(File file, String fileFormat)	{
+		return this.getSWTChartsComponentsProvider().exportView(this, file, fileFormat);
+	}
+
+	/**
+	 * Gets the parent multipages editor part if exists.
+	 * @return the parentMultiPagesEditor
+	 */
+	public MultiPageEditorPart getParentMultiPagesEditor() {
+		return parentMultiPagesEditor;
+	}
+
+	/**
+	 * Sets the specified multipages editor part as parent of this one.
+	 * @param parentMultiPagesEditor the parentMultiPagesEditor to set
+	 */
+	public void setParentMultiPagesEditor(MultiPageEditorPart parentMultiPagesEditor) {
+		this.parentMultiPagesEditor = parentMultiPagesEditor;
+	}
+
+	/**
+	 * To check whether this editor was already opened when calling SWTChartsComponentsProvider.openEditor().
+	 * @return the wasAlreadyOpened
+	 */
+	public boolean wasAlreadyOpened() {
+		return wasAlreadyOpened;
+	}
+
+	/**
+	 * To check whether this editor was already opened when calling SWTChartsComponentsProvider.openEditor().
+	 * @param wasAlreadyOpened the wasAlreadyOpened to set
+	 */
+	public void setWasAlreadyOpened(boolean wasAlreadyOpened) {
+		this.wasAlreadyOpened = wasAlreadyOpened;
+	}
+
+	/**
+	 * Checks whatever the chart composite has the focus or not.
+	 * @return <code>true</code> if the chart composite has the focus otherwise <code>false</code>
+	 */
+	public boolean hasFocus()	{
+		return this.chartComposite.hasFocus();
+	}
+
+	/**
+	 * Gets the chart composite.
+	 * @return the chartComposite
+	 */
+	public ChartComposite getChartComposite() {
+		return chartComposite;
+	}
+
+	/**
+	 * Gets the chart toolbar.
+	 * @return the chartToolBar
+	 */
+	public ChartEditorToolBar getChartToolBar() {
+		return chartToolBar;
+	}
+
+	
+	
+	@Override
+	public T getResult()	{
+		return (T) this.getEditorInput().getResult();
+	}
+	
+
+}
\ No newline at end of file
